<template>
  <div class="app-container">
    <div class="operation">
      <el-button v-if="isRoleEdit" class="success" @click="form_add">新增</el-button>
      <el-button v-if="isRoleEdit" class="danger" @click="handleDelete">删除</el-button>
    </div>

    <div class="search">
      <el-input v-model="table.getdataListParm.parammaps.drivername" placeholder="驾驶员名称" style="width: 180px;" class="filter-item" clearable />
      <el-input v-model="table.getdataListParm.parammaps.drivercode" placeholder="驾驶员编号" style="width: 180px;" class="filter-item" clearable />
      <el-select v-model="table.getdataListParm.parammaps.enable" filterable placeholder="是否启用" class="filter-item" style="width: 120px;" clearable>
        <el-option v-for="(item,index) in enableList" :key="index" :label="item.name" :value="item.id" />
      </el-select>

      <el-button class="successBorder" @click="form_search">查询</el-button>
      <el-button class="successBorder" @click="form_clear">重置</el-button>
    </div>

    <div class="table">
      <el-table :key="table.tableKey" v-loading="table.listLoading" element-loading-text="给我一点时间" :data="table.list" border fit highlight-current-row style="width: 100%;" :row-style="rowStyle" :cell-style="cellStyle" class="elTable table-fixed" @selection-change="change_table_selection">
        <el-table-column type="selection" align="center" width="50" />
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="驾驶员编号" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.drivercode }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.drivercode" placeholder="1-32个字符" type="textarea" :autosize="{ minRows: 1.3, maxRows: 4}" maxlength="32" style="width:95%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column label="驾驶员名称" min-width="130px" align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.NoEdit">{{ scope.row.drivername }}</span>
            <el-input v-if="scope.row.Edit" v-model="scope.row.drivername" placeholder="1-32个字符" type="textarea" :autosize="{ minRows: 1.3, maxRows: 4}" maxlength="32" style="width:95%;padding:10px 0;" />
          </template>
        </el-table-column>
        <el-table-column label="是否启用" min-width="110px" align="center">
          <template slot-scope="scope">
            <el-switch v-model="scope.row.enable" :disabled="scope.row.NoEdit==true" active-color="#13ce66" inactive-color="#ff4949" :active-value="1" :inactive-value="0" @change="change_enable(scope.$index, scope.row)" />
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="250" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="{row}">
            <!-- 新增 -->
            <el-button v-if="row.isCreate" :disabled="isokDisable" class="miniSuccess" @click="add_dialog_save(row)">保存</el-button>
            <el-button v-if="row.isCreate" class="minCancel" @click="add_cancel(row)">取消</el-button>
            <!-- 编辑 -->
            <el-button v-if="row.isUpdate && isRoleEdit" class="miniSuccess" @click="form_edit(row)">编辑</el-button>
            <el-button v-if="row.isUpdate && isRoleEdit" class="miniDanger" @click="form_delete(row)">删除</el-button>
            <!-- 编辑保存 -->
            <el-button v-if="row.isUpdateSave" :disabled="isokDisable" class="miniSuccess" @click="form_edit_save(row)">保存</el-button>
            <el-button v-if="row.isUpdateSave" class="minCancel" @click="edit_cancel(row)">取消</el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="get_table_data" />
    </div>
  </div>

</template>

<script>
import { GetDataByName, PostDataByName, failproccess, ExecDataByConfig, checkButtons, calculativeWidth } from '@/api/common'
import Cookies from 'js-cookie'
import Pagination from '@/components/Pagination'
import { MessageBox } from 'element-ui'
export default {
  name: 'Driver',
  components: { Pagination },
  data() {
    return {
      isRoleEdit: [],
      enableList: [{ id: 1, name: '是' }, { id: 0, name: '否' }], // 是否启用

      table: {
        getdataListParm: {
          name: 'getDriverList',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            enable: '',
            drivername: '',
            drivercode: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true,
        temp: {}
      },
      requestParam: {},
      isokDisable: false,
      selectList: [],
      rowStyle: { maxHeight: 50 + 'px', height: 45 + 'px' },
      cellStyle: { padding: 0 + 'px' }

    }
  },

  created() {
    this.get_table_data()
    this.get_auto_buttons()
  },

  methods: {
    get_auto_buttons() {
      const Edit = 'Driver'
      const isRoleEdit = checkButtons(JSON.parse(sessionStorage.getItem('buttons')), Edit)
      this.isRoleEdit = isRoleEdit
    },
    get_table_data() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            this.$set(response.data.list[i], 'Edit', false) // 编辑
            this.$set(response.data.list[i], 'NoEdit', true) // 不可编辑/输入
            this.$set(response.data.list[i], 'isCreate', false) // 新增操作
            this.$set(response.data.list[i], 'isUpdate', true) // 编辑操作
            this.$set(response.data.list[i], 'isUpdateSave', false) // 编辑保存
          }
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },
    change_enable() {
      console.log('点击了是否启用')
    },

    form_search() {
      console.log('点击了查询')
      this.table.getdataListParm.offset = 1
      this.get_table_data()
    },
    form_clear() {
      console.log('点击了重置')
      this.table.getdataListParm.parammaps.drivername = ''
      this.table.getdataListParm.parammaps.enable = ''
      this.table.getdataListParm.parammaps.drivercode = ''
      this.table.getdataListParm.offset = 1
      this.get_table_data()
    },

    form_add() {
      // 编辑true/不可编辑false
      // 新增操true,编辑false，编辑保存false
      for (let i = 0; i < this.table.list.length; i++) {
        if (this.table.list[i].Edit === true) {
          console.log(123)
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      this.table.list.unshift({ 'myId': (new Date()).valueOf(), 'Edit': true, 'NoEdit': false, 'isCreate': true, 'isUpdate': false, 'isUpdateSave': false, 'enable': 1, 'drivercode': '', 'drivername': '' })
    },
    add_dialog_save(row) {
      console.log('点击了新增保存', row)
      this.table.temp.pastureid = Cookies.get('pastureid')
      this.table.temp.drivercode = row.drivercode
      this.table.temp.drivername = row.drivername
      this.table.temp.enable = row.enable
      // 检验用户名称/角色是否为空
      if (this.table.temp.drivercode == '' && this.table.temp.drivername == '') {
        this.$message({ type: 'error', message: '驾驶员编号/驾驶员名称不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.drivercode == '') {
        this.$message({ type: 'error', message: '驾驶员编号不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.drivername == '') {
        this.$message({ type: 'error', message: '驾驶员名称不能为空', duration: 2000 })
        return false
      }

      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.requestParam.name = 'insertDriver'
      this.requestParam.parammaps = this.table.temp
      PostDataByName(this.requestParam).then(response => {
        console.log('新增保存发送参数', this.requestParam)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.get_table_data()
        } else {
          failproccess(response, this.$notify)
        }
      })
    },
    add_cancel(row) {
      console.log('点击了新增取消')
      for (let i = 0; i < this.table.list.length; i++) {
        if (row.myId === this.table.list[i].myId) {
          var listIndex = this.table.list.indexOf(this.table.list[i])
        }
        if (listIndex > -1) {
          this.table.list.splice(listIndex, 1)
          return
        }
      }
    },
    form_edit(row) {
      for (let i = 0; i < this.table.list.length; i++) {
        if (this.table.list[i].Edit == true) {
          this.$message({ type: 'error', message: '当前内容未保存，请点击取消或保存继续进行操作', duration: 2000 })
          return false
        }
      }
      // 编辑true,不可编辑false
      row.Edit = true
      row.NoEdit = false
      // 新增false,编辑false,编辑保存true
      row.isCreate = false
      row.isUpdate = false
      row.isUpdateSave = true
    },
    form_edit_save(row) {
      console.log('点击了编辑保存', row)
      this.table.temp.pastureid = row.pastureid
      this.table.temp.drivercode = row.drivercode
      this.table.temp.drivername = row.drivername
      this.table.temp.enable = row.enable
      this.table.temp.id = row.id
      // 检验用户名称/角色是否为空
      console.log(this.table.temp.drivercode)
      console.log(this.table.temp.drivername)
      if (this.table.temp.drivercode == '' && this.table.temp.drivername == '') {
        this.$message({ type: 'error', message: '驾驶员编号/驾驶员名称不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.drivercode == undefined || this.table.temp.drivercode == '') {
        this.$message({ type: 'error', message: '驾驶员编号不能为空', duration: 2000 })
        return false
      } else if (this.table.temp.drivername == undefined || this.table.temp.drivername == '') {
        this.$message({ type: 'error', message: '驾驶员名称不能为空', duration: 2000 })
        return false
      }

      this.isokDisable = true
      setTimeout(() => {
        this.isokDisable = false
      }, 1000)
      this.requestParam.name = 'updateDriver'
      this.requestParam.parammaps = this.table.temp
      PostDataByName(this.requestParam).then(response => {
        console.log('编辑保存发送参数', this.requestParam)
        if (response.msg !== 'fail') {
          this.$notify({ title: '成功', message: '保存成功', type: 'success', duration: 2000 })
          this.get_table_data()
        } else {
          failproccess(response, this.$notify)
        }
      })
    },
    edit_cancel(row) {
      console.log('点击了编辑取消')
      // 编辑false,不可编辑true
      row.Edit = false
      row.NoEdit = true
      // 新增false,编辑true,编辑保存false
      row.isCreate = false
      row.isUpdate = true
      row.isUpdateSave = false
      this.get_table_data()
    },
    form_delete(row) {
      console.log('点击了行内删除')
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.selectList = []
        this.requestParam.name = 'deleteDriver'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = row.pastureid
        this.requestParam.parammaps.id = row.id
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
            this.get_table_data()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    },
    change_table_selection(val) {
      console.log('勾选数据', val)
      this.selectList = val
    },
    handleDelete() {
      console.log('点击了删除')
      if (this.selectList.length == 0) {
        this.$message({ type: 'error', message: '请选择驾驶员信息', duration: 2000 })
      } else {
        MessageBox.confirm('当前选中' + this.selectList.length + '条信息，是否删除?', {
          confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
        }).then(() => {
          console.log(this.selectList)
          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertSpotList', 'resultmaps': { 'list': this.selectList } }
          this.requestParam.data[0].children = []
          this.requestParam.data[0].children[0] = {            'name': 'deleteDriver', 'type': 'e', 'parammaps': {
              id: '@insertSpotList.id',
              pastureid: '@insertSpotList.pastureid'
            }          }
          ExecDataByConfig(this.requestParam).then(response => {
            console.log('删除保存发送参数', this.requestParam)
            if (response.msg === 'fail') {
              this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
            } else {
              this.$notify({ title: '', message: '删除成功', type: 'success', duration: 2000 })
              this.get_table_data()
            }
          })
        })
      }
    }
  }
}
</script>
<style lang="scss" scoped>
.search {
  margin-top: 10px;
}
.table {
  margin-top: 10px;
}
</style>
